
package parsers;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.HashMap;
import java.util.StringTokenizer;

import utils.ConfigReader;

public class GinFile
{
	public static HashMap<String,String> parseGin(String filePath) throws Exception
	{
		return parseGin( new File(filePath));
	}
	
    /**
     *   The key is the Affy Id
     */
    public static HashMap<String,String> parseGin(File file) throws Exception
    {
        HashMap<String, String> map = new HashMap<String, String>();
        
        BufferedReader reader = new BufferedReader(new FileReader(file));
        
        for (int x=1; x<=7; x++)
            reader.readLine();
        
        String nextLine = reader.readLine();
        
        while (nextLine != null && nextLine.trim().length() > 0 )
        {
            StringTokenizer sToken = new StringTokenizer(nextLine);
            
           // for ( int x=1; x <=3; x++)
            	sToken.nextToken();
            
            String key = sToken.nextToken();
            
            map.put(key, nextLine );
            nextLine = reader.readLine();
        }
        
        reader.close();
        
        return map;
    }
    
    public static void main(String[] args) throws Exception
    {
    	HashMap<String,String> keys = GinFile.parseGin(new File(
				ConfigReader.getChristineCel() + File.separator + "Mouse430_2.gin"));
    	
    	int x=0;
    	
    	for( String s : keys.keySet() )
    	{
    		System.out.println(s);
    		
    		if ( ++x == 100)
    			System.exit(1);
    	}
    		
    }
}
