package parsers;

public class NumTrueAndFalsePositives
{
	private final int numTruePositives;
	private final int numFalsePositives;
	
	
	public NumTrueAndFalsePositives(int numTruePositives, int numFalsePositives)
	{
		this.numTruePositives = numTruePositives;
		this.numFalsePositives = numFalsePositives;
	}
	
	public int getNumChosen()
	{
		return numTruePositives + numFalsePositives;
	}

	public int getNumFalsePositives()
	{
		return numFalsePositives;
	}

	public int getNumTruePositives()
	{
		return numTruePositives;
	}
	
	public float getSpeceficity()
	{
		float tp = numTruePositives;
		
		return tp / ( tp + numFalsePositives ); 
	}
	
	public float getSensitivity(float totalNumOfTruePositives)
	{
		return numTruePositives / totalNumOfTruePositives;
	}
	
}
