package statistics;

import dataSetDescribers.ExperimentData;
import dataSetDescribers.ProbeSetData;
import utils.StatisticReturnObject;

public interface StatisticsProvider
{
	public void preliminaryCalculations( ExperimentData experiment ) throws Exception;
	
	/*
	 *   The p-value will be undefined if ! hasPValue();
	 */
	public StatisticReturnObject getStats( ProbeSetData probeSet ) throws Exception;
	
	public boolean hasPValue();
	
	public String getDescription();
}
