
package utils;

public class BaseNumber
{
    private final int base;
    private final int[] indexes;
    private int pointer;
    
    public static void main(String[] args) throws Exception
    {
        BaseNumber bn = new BaseNumber(2, 6);
        
        do
        {
        	   System.out.println( bn.getNumberAsString() + " " + bn.digitsAscendingLeftToRight() );
        	   
            bn.advance();
            
        } 
        while( bn.canAdvance());
    }
    
    public String getNumberAsString()
    {
    		StringBuffer buff = new StringBuffer();
    		
    		for ( int x=0; x < indexes.length; x++)
    			buff.append("" + indexes[x]);
    		
    		return buff.toString();
    }
    
    /**
     *   Do not change the contents of this array
     */
    public int[] getNumber()
    {
        return this.indexes;
    }
    
    public BaseNumber(int base, int numDigits )
    {
        this.base = base;
        this.indexes = new int[numDigits];
        
        for ( int x=0; x < numDigits; x++)
            indexes[x] = 0;
        
        pointer = numDigits - 1;
    }
    
    public boolean containsDigit(int digit)
    {
    		for ( int x=0; x < indexes.length; x++)
    			if( indexes[x] == digit )
    				return true;
    	
    		return false;
    }
    
    public boolean digitsAscendingLeftToRight()
    {
    		if ( indexes.length < 2)
    			return true;
    		
    		int trailingDigit = indexes[0];
    		
    		for ( int x=1; x < indexes.length; x++)
    		{
    			if ( indexes[x] <= trailingDigit )
    				return false;
    			else
    				trailingDigit = indexes[x];
    		}
    		
    		return true;
    }
    
    public boolean containsDuplicateDigit()
    {
    		for ( int x=0; x< indexes.length; x++)
    			for ( int y=x+1; y < indexes.length; y++)
    				if( indexes[x] == indexes[y] )
    					return true;
    		
    		return false;
    }
    
    public void advance() throws Exception
    {
        if ( ! canAdvance())
            throw new Exception("Can't advance");
        
        pointer = indexes.length -1;
        
        increment();
    }
    
    private void increment()
    {
        if ( pointer == -1 )
            return;
        
        indexes[pointer]++;
        
        if ( indexes[pointer] == base ) 
        {
            indexes[pointer]=0;
            pointer--;
            increment();
        }
    }
    
    public boolean canAdvance()
    {
        if ( indexes.length == 0 )
            return false;
        
        return pointer != -1;
    }
}
