package utils;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.StringTokenizer;
/*
import dataSetDescribers.DataScope;
import dataSetDescribers.LatinSquareGeneric;
import dataSetDescribers.RatioExperiment;

import parsers.ScoreFileLineParser;
import statistics.CyberT;
import statistics.StatisticsProvider;
*/
public class KS_Test
{
	/*
	 *   Lists get sorted as a side effect.
	 */
	public static double getKS_P_Value(List<Double> data1, List<Double> data2)
	{
		double d, prob;
		int j1=0,j2=0;
		double d1,d2,dt,en1,en2,en,fn1=0.0,fn2=0.0;

		int n1=data1.size();
		int n2=data2.size();
		Collections.sort(data1);
		Collections.sort(data2);
		en1=n1;
		en2=n2;
		d=0.0;
		while (j1 < n1 && j2 < n2) {
			if ((d1=data1.get(j1)) <= (d2=data2.get(j2))) fn1=j1++/en1;
			if (d2 <= d1) fn2=j2++/en2;
			if ((dt=Math.abs(fn2-fn1)) > d) d=dt;
		}
		en=Math.sqrt(en1*en2/(en1+en2));
		prob=probks((en+0.12+0.11/en)*d);
		return prob;
	}
	
	/*
	 * DP NR::probks(const DP alam)
{
	const DP EPS1=1.0e-6,EPS2=1.0e-16;
	int j;
	DP a2,fac=2.0,sum=0.0,term,termbf=0.0;

	a2 = -2.0*alam*alam;
	for (j=1;j<=100;j++) {
		term=fac*exp(a2*j*j);
		sum += term;
		if (fabs(term) <= EPS1*termbf || fabs(term) <= EPS2*sum) return sum;
		fac = -fac;
		termbf=fabs(term);
	}
	return 1.0;
}
	 */
	
	public static double probks(double alam)
	{
		double EPS1=1.0e-6,EPS2=1.0e-16;
		int j;
		double a2,fac=2.0,sum=0.0,term,termbf=0.0;

		a2 = -2.0*alam*alam;
		for (j=1;j<=100;j++) {
			term=fac*Math.exp(a2*j*j);
			sum += term;
			if (Math.abs(term) <= EPS1*termbf || Math.abs(term) <= EPS2*sum) return sum;
			fac = -fac;
			termbf=Math.abs(term);
		}
		return 1.0;
	}
	
	/*
	public static void main(String[] args) throws Exception
	{
		
		
		List<Double> l1 = new ArrayList<Double>();
		List<Double> l2 = new ArrayList<Double>();
		
		BufferedReader reader = new BufferedReader(new FileReader(new File(
				"c:\\javaresults\\LatinSquareAveraged3\\null8vs9NOSLN.txt")));
		
		
		reader.readLine(); //throw away header
		
		String nextLine = reader.readLine();
		
		while( nextLine != null)
		{
			StringTokenizer sToken = new StringTokenizer(nextLine);
			sToken.nextToken();
			sToken.nextToken();
			sToken.nextToken();
			sToken.nextToken();
			sToken.nextToken();
			
			l1.add(Double.parseDouble(sToken.nextToken()));
			l2.add(Double.parseDouble(sToken.nextToken()));
			nextLine = reader.readLine();
		}
		
		System.out.println(KS_Test.getKS_P_Value(l1, l2));
	} 
	
	/*
	/*public static void main(String[] args) throws Exception
	{
		List<? extends RatioExperiment> list = LatinSquareGeneric.getAll2X();
		
		for( RatioExperiment re : list ) 
		{
			List<Double> l1 = new ArrayList<Double>();
			List<Double> l2 = new ArrayList<Double>();
			
			re.setUseQuantileQuantileNormalization(true);
			re.setUseStatisticLevelNormalization(false);
			re.setDataScope(DataScope.NULLS_ONLY);
			StatisticsProvider sp = new CyberT();
			
			for( ScoreFileLineParser sflp : ScoreFileLineParser.parseFile(re,sp) )
			{
				l1.add( sflp.getExpectedPValue() );
				double t= sflp.getScore();
				double df = 200;
				
				double prob = TTest.betai( 0.5 * df, 0.5, df / ( df + t * t ));
				
				l2.add( prob);
			}
			
			double pValue = KS_Test.getKS_P_Value(l1, l2);
			System.out.println( re.getShortExperimentName() + "\t" +  -Math.log10(pValue));
		}
		
		
	}
	
	*/
	public static void main(String[] args) throws Exception
	{

		List<ArrayList<Double>> l1 = new ArrayList<ArrayList<Double>>();
		List<ArrayList<Double>> l2 = new ArrayList<ArrayList<Double>>();
		
		BufferedReader reader = new BufferedReader(new FileReader(new File(
				"c:\\javaresults\\LatinSquareAveraged3\\null_pvalueandexpected_NOSLN.txt")));
		
		
		reader.readLine(); //throw away header
		
		String nextLine = reader.readLine();
		
		while( nextLine != null)
		{
			ArrayList<Double> l1temp = new ArrayList<Double>();
			ArrayList<Double> l2temp = new ArrayList<Double>();
			
			StringTokenizer sToken = new StringTokenizer(nextLine);
			for (int i =0; i < 13; i++)
			{
				l1temp.add(Double.parseDouble(sToken.nextToken()));
				//System.out.println(i);
				
			}
			for (int i =0; i < 13; i++)
			{
				String s = sToken.nextToken();
				l2temp.add(Double.parseDouble(s));
				System.out.println(i + " OUr value is " + s);
			}
			l1.add(l1temp);
			l2.add(l2temp);
			
			nextLine = reader.readLine();
		}
		
		//grab all values in a column and then perform KS test.		
		for (int j = 0; j < 13; j++)
		{
			ArrayList<Double> columnList1 = new ArrayList<Double>();
			ArrayList<Double> columnList2 = new ArrayList<Double>();
			
			for (int i =0; i < l1.size(); i++)
			{
				columnList1.add(l1.get(i).get(j));
				columnList2.add(l2.get(i).get(j));
			}
			
			System.out.println(KS_Test.getKS_P_Value(columnList1, columnList2));
		}
		
		
	}
	
}
