package utils;

import java.util.List;

public class Pearson
{
	public static final double TINY=1.0e-20;
	
	
	public static double getPearsonR(List<? extends Number> x, List<? extends Number> y)
	{
		
		int j;
		double yt,xt;
		double syy=0.0,sxy=0.0,sxx=0.0,ay=0.0,ax=0.0;

		int n=x.size();
		for (j=0;j<n;j++) {
			ax += x.get(j).doubleValue();
			ay += y.get(j).doubleValue();
		}
		ax /= n;
		ay /= n;
		for (j=0;j<n;j++) {
			xt=x.get(j).doubleValue()-ax;
			yt=y.get(j).doubleValue()-ay;
			sxx += xt*xt;
			syy += yt*yt;
			sxy += xt*yt;
		}
		return sxy/(Math.sqrt(sxx*syy)+TINY);
	}
	
	public static double getPearsonRFromFloat(List<Float> x, List<Float> y)
	{
		
		int j;
		double yt,xt;
		double syy=0.0,sxy=0.0,sxx=0.0,ay=0.0,ax=0.0;

		int n=x.size();
		for (j=0;j<n;j++) {
			ax += x.get(j).doubleValue();
			ay += y.get(j).doubleValue();
		}
		ax /= n;
		ay /= n;
		for (j=0;j<n;j++) {
			xt=x.get(j).doubleValue()-ax;
			yt=y.get(j).doubleValue()-ay;
			sxx += xt*xt;
			syy += yt*yt;
			sxy += xt*yt;
		}
		return sxy/(Math.sqrt(sxx*syy)+TINY);
	}
}
